package com.isomorphic.examples.atmosphere.server;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.atmosphere.annotation.Broadcast;
import org.atmosphere.annotation.Suspend;
import org.atmosphere.cpr.Broadcaster;
import org.atmosphere.cpr.BroadcasterFactory;

import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;

@Path("/quotes/{channelid}")
public class JerseyRpc {
	
	private 
	@PathParam("channelid") 
	Broadcaster channel; 
	
	@GET
	@Suspend
	@Produces("application/json")
	public String suspendGet() {
		return null;
	}
	
	@POST
	@Suspend
	@Broadcast(writeEntity = false)
	@Produces("application/json")
	public void broadcast(String message) {
		if(message.equals("start")) {
			System.out.println("Start sending data to channel " + channel.getID());
			sendResponses(channel.getID());
		} else {
			System.out.println("Invalid command " + message +
					" received in channel " + channel.getID());
		}
	}
	
	public static void sendResponses(final String channelId) {
		new Thread() {  
			public void run() {  
				try {  
					Random generator = new Random();
					
					Broadcaster channel = BroadcasterFactory.getDefault().lookup(channelId);

					List<Object[]> stockData = new ArrayList<Object[]>();
					long endTime = System.currentTimeMillis() + 90000;  
					while (System.currentTimeMillis() < endTime) {  
						stockData.clear();  
						for (int i = 1; i <= 10; i++) {  
							stockData.add(new Object[] { i, 0 });  
						}  
						int cnt = 1 + generator.nextInt(3);  
						for (int i = 0; i < cnt; i++) {  
							int id = 1 + generator.nextInt(10);  
							for (Object[] sd : stockData) {  
								if (((Integer) sd[0]).intValue() == id) {  
									sd[1] = ((float) (generator.nextInt(101) - 50)) / 100;  
									break;  
								}  
							}  
						}  

						JsonResponse response = new JsonResponse(stockData);
						channel.broadcast(response);
						
					    Thread.sleep(500);  
					}  
				} catch (Exception e) {  
					e.printStackTrace(System.out);  
				}  
			};  
		}.start();
	}
}